﻿Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles
Imports System.Collections.ObjectModel
<Serializable()>
Public Class CustomPagePrinterLayer
   Inherits PagePrinterLayer
   Public Property LeftMargin As Double = 0.75
  Public Property TopMargin As Double = 0.75
  Public Property RightMargin As Double = 0.75
  Public Property BottomMargin As Double = 0.75
  Private moBorderExtent As RectangleShape = Nothing
   Private moBorderStyle As AreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Black, 3)
   Public Sub New()
      MyBase.New()
   End Sub
   Protected Overrides Sub DrawCore(canvas As GeoCanvas, labelsInAllLayers As ObjectModel.Collection(Of SimpleCandidate))
      If moBorderExtent Is Nothing Then
         SetBorderPosition()
      End If
      Dim oShapes As New Collection(Of RectangleShape) From {(moBorderExtent)}

      moBorderStyle.Draw(oShapes, canvas, labelsInAllLayers, labelsInAllLayers)

      MyBase.DrawCore(canvas, labelsInAllLayers)
   End Sub
   Public Sub SetBorderPosition()
      Dim dMinX As Double
      Dim dMaxX As Double
      Dim dMinY As Double
      Dim dMaxY As Double
      Dim oPageBoundingBox As RectangleShape = GetPosition()

      '***** Construct a rectangle to be used for drawing a border 
      dMinX = oPageBoundingBox.UpperLeftPoint.X + (LeftMargin * 96)
      dMaxX = oPageBoundingBox.UpperRightPoint.X - (RightMargin * 96)

      dMinY = oPageBoundingBox.LowerLeftPoint.Y + (BottomMargin * 96)
      dMaxY = oPageBoundingBox.UpperLeftPoint.Y - (TopMargin * 96)

      moBorderExtent = New RectangleShape(dMinX, dMaxY, dMaxX, dMinY)
      moBorderStyle.DrawingLevel = DrawingLevel.LabelLevel
      'SetPosition(moBorderExtent, PrintingUnit.Inch)

   End Sub

End Class
