﻿Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles
Public Class PageBorderPrinterLayer
	Inherits PrinterLayer
	Public Property LeftMargin As Double
	Public Property TopMargin As Double
	Public Property RightMargin As Double
	Public Property BottomMargin As Double
	Public Sub New(dLeft As Double, dTop As Double, dRight As Double, dBottom As Double)
		MyBase.New()
		LeftMargin = dLeft
		TopMargin = dTop
		RightMargin = dRight
		BottomMargin = dBottom
		Me.DragMode = PrinterDragMode.Fixed
		Me.ResizeMode = PrinterResizeMode.Fixed
		BackgroundMask = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Black, 3)
	End Sub
	Protected Overrides Sub CloseCore()
		MyBase.CloseCore()
	End Sub
	Public Sub SetBorderPosition(oPageBoundingBox As RectangleShape)
		Dim dCenterX As Double
		Dim dCenterY As Double

		Dim dWidth As Double = oPageBoundingBox.Width - LeftMargin - RightMargin
		Dim dHeight As Double = oPageBoundingBox.Height - TopMargin - BottomMargin

		dCenterX = (dWidth / 2) + oPageBoundingBox.UpperLeftPoint.X + LeftMargin
		dCenterY = oPageBoundingBox.UpperLeftPoint.Y - (dHeight / 2) - TopMargin

		'dCenterPointX = oMapBoundingBox.UpperLeftPoint.X + (dWidth / 2) + dDistanceFromEdge
		'dCenterPointY = oMapBoundingBox.UpperLeftPoint.Y - (dHeight / 2) - dDistanceFromEdge

		SetPosition(dWidth, dHeight, dCenterX, dCenterY, PrintingUnit.Inch)

	End Sub

End Class
